Bug 864786 - Eager locking lk-owner decision is taken before transaction type is set
Eager locking lk-owner decision is taken before transaction type is set
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: replicate (Show other bugs)
mainline
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Pranith Kumar K
:
Depends On:
Blocks: 865321 895528
  Show dependency treegraph
 
Reported: 2012-10-10 02:39 EDT by Pranith Kumar K
Modified: 2015-12-01 11:45 EST (History)
2 users (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 865321 (view as bug list)
Environment:
Last Closed: 2013-07-24 13:09:59 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Pranith Kumar K 2012-10-10 02:39:44 EDT
Description of problem:
Eager locking lk-owner decision is taken before transaction type is set.
Default transaction type is DATA so all transactions are treated as DATA transactions at the time of eager-locking decision.

Breakpoint 1, afr_transaction (frame=0x7f45fd7f8008, this=0x1f73e90, type=AFR_ENTRY_TRANSACTION) at afr-transaction.c:1452
1452	        afr_local_t *   local = NULL;
(gdb) n
1453	        afr_private_t * priv  = NULL;
(gdb) 
1454	        fd_t            *fd   = NULL;
(gdb) 
1456	        local = frame->local;
(gdb) 
1457	        priv  = this->private;
(gdb) 
1459		if (local->fd && priv->eager_lock &&
(gdb) 
1463			afr_set_lk_owner (frame, this, frame->root);
(gdb) p local->transaction.type 
$1 = AFR_DATA_TRANSACTION

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Vijay Bellur 2012-10-10 22:11:40 EDT
CHANGE: http://review.gluster.org/4053 (cluster/afr: check transaction type for eager-lock after it is set) merged in master by Anand Avati (avati@redhat.com)

Note You need to log in before you can comment on or make changes to this bug.